ServerEvents.recipes(event => {

  event.campfireCooking('minecraft:torch', 'minecraft:stick').cookingTime(200)

  event.shapeless(
    Item.of('minecraft:packed_mud', 1),
    [
      'minecraft:dirt',
      'minecraft:clay_ball',
      'farmersdelight:straw'
    ]
  );

  event.shaped(
    Item.of('minecraft:recovery_compass', 1),
    [
      'AAA',
      'ABA',
      'AAA'
    ],
    {
      A: 'minecraft:echo_shard',
      B: '#fantasia:compass'
    }
  );

  event.shapeless(
    Item.of('spelunkery:portal_fluid_bottle', 1),
    [
      'spelunkery:portal_fluid_bottle'
    ]
  );

  event.custom({
    "type": "minecraft:crafting_shaped",
    "key": {
      "x": {
        "item": "minecraft:black_dye"
      },
      "y": {
        "item": "minecraft:bone_meal"
      },
      "z": {
        "type": "forge:partial_nbt",
        "item": "minecraft:potion",
        "nbt": "{Potion:\"minecraft:water\"}"
      }
    },
    "pattern": [
      "xy",
      "z "
    ],
    "result": {
      "item": "minecraft:ink_sac"
    }
  })

  event.shaped(
    Item.of('minecraft:campfire', 1),
    [
      'AA',
      'BB'
    ],
    {
      A: 'minecraft:stick',
      B: '#minecraft:logs'
    }
  );

  event.shaped(
    Item.of('spelunkery:wooden_channel', 2),
    [
      'A A',
      'AAA',
      'B B'
    ],
    {
      A: '#minecraft:wooden_slabs',
      B: '#minecraft:fences'
    }
  );

  event.shaped(
    Item.of('spelunkery:stone_channel', 2),
    [
      'A A',
      'AAA',
      'B B'
    ],
    {
      A: 'minecraft:stone_brick_slab',
      B: 'minecraft:stone_brick_wall'
    }
  );

  event.shaped(
    Item.of('minecraft:saddle', 1),
    [
      ' A ',
      'ABA'
    ],
    {
      A: 'minecraft:leather',
      B: 'minecraft:iron_ingot'
    }
  );

  event.shaped(
    Item.of('supplementaries:sack', 1),
    [
      'BAB',
      'B B',
      'BBB'
    ],
    {
      A: 'minecraft:string',
      B: 'farmersdelight:canvas'
    }
  );

  event.shaped(
    Item.of('coinsje:gold_coin_pile', 1),
    [
      'AAA',
      'AAA',
      'AAA'
    ],
    {
      A: 'coinsje:gold_coin'
    }
  );

  event.shapeless(
    Item.of('coinsje:gold_coin', 9),
    [
      'coinsje:gold_coin_pile'
    ]
  );

  event.shapeless(
    Item.of('minecraft:string', 3),
    [
      '#minecraft:wool',
      '#farmersdelight:tools/knives'
    ]
  ).damageIngredient("#farmersdelight:tools/knives", 1);

  event.shaped(
    Item.of('minecraft:torch', 1),
    [
      'BC',
      'A '
    ],
    {
      A: 'minecraft:stick',
      B: '#fantasia:coal_recipe',
      C: 'farmersdelight:straw'
    }
  );

  event.shapeless(
    Item.of('minecraft:mud', 1),
    [
      'minecraft:dirt',
      'minecraft:water_bucket'
    ]
  ).keepIngredient('minecraft:water_bucket');

  event.shapeless(
    Item.of('minecraft:mud', 1),
    [
      'regions_unexplored:silt_dirt',
      'minecraft:water_bucket'
    ]
  ).keepIngredient('minecraft:water_bucket');

  event.shapeless(
    Item.of('regions_unexplored:peat_mud', 1),
    [
      'regions_unexplored:peat_dirt',
      'minecraft:water_bucket'
    ]
  ).keepIngredient('minecraft:water_bucket');

  event.shapeless(
    Item.of('minecraft:map', 1),
    [
      '#minecraft:compasses',
      'minecraft:paper'
    ]
  ).keepIngredient('#minecraft:compasses');

  event.shapeless(
    Item.of('irons_spellbooks:arcane_essence', 2),
    [
      'minecraft:amethyst_shard',
      'galosphere:allurite_shard',
      'minecraft:quartz',
      'overgeared:smithing_hammer'
    ]
  ).damageIngredient('overgeared:smithing_hammer', 3);

  event.shapeless(
    Item.of('farmersdelight:wheat_dough', 1),
    [
      'minecraft:wheat',
      'minecraft:potion'
    ]
  ).replaceIngredient('minecraft:potion', 'minecraft:glass_bottle');

  event.shapeless(
    Item.of('farmersdelight:wheat_dough', 1),
    [
      'regions_unexplored:barley',
      'minecraft:potion'
    ]
  ).replaceIngredient('minecraft:potion', 'minecraft:glass_bottle');

  event.shapeless(
    Item.of('minecraft:crying_obsidian', 1),
    [
      'minecraft:obsidian',
      'minecraft:ghast_tear',
      'irons_spellbooks:arcane_essence'
    ]
  );
  
  event.shaped(
    Item.of('clayworks:kiln', 1),
    [
      "AAA",
      "A A",
      "CCC"
    ],
    {
      A: 'minecraft:cobblestone',
      C: 'minecraft:mud_bricks'
    }
  );

});